import databaseRefreshHandler from '~background/messages/database/refresh';
import {
  EXTENSION_MENU_ITEM_ID,
  REPORT_MENU_ITEM_ID,
  SETTINGS_MENU_ITEM_ID,
} from '~utils/constants';
import { noop } from '~utils/error';
import { storage } from '~utils/storage';

export default async function onInstalled() {
  await chrome.contextMenus.removeAll();

  const documentUrlPatterns = chrome.runtime.getManifest().content_scripts?.[0].matches;

  await chrome.contextMenus.create({
    contexts: ['all'],
    documentUrlPatterns,
    id: EXTENSION_MENU_ITEM_ID,
    title: 'Cookie Dialog Monster',
  });
  await chrome.contextMenus.create({
    contexts: ['all'],
    documentUrlPatterns,
    id: SETTINGS_MENU_ITEM_ID,
    parentId: EXTENSION_MENU_ITEM_ID,
    title: chrome.i18n.getMessage('contextMenu_settingsOption'),
  });
  await chrome.contextMenus.create({
    contexts: ['all'],
    documentUrlPatterns,
    id: REPORT_MENU_ITEM_ID,
    parentId: EXTENSION_MENU_ITEM_ID,
    title: chrome.i18n.getMessage('contextMenu_reportOption'),
  });

  await storage.remove('updateAvailable');
  await databaseRefreshHandler({ name: 'database/refresh' }, { send: noop });
}
