import { sendToContentScript } from '@plasmohq/messaging';

export default async function onErrorOccurred(details: chrome.webRequest.WebResponseErrorDetails) {
  const { error, tabId } = details;

  if (error === 'net::ERR_BLOCKED_BY_CLIENT' && tabId > -1) {
    await sendToContentScript({
      body: {
        value: error,
      },
      name: 'INCREASE_LOG_COUNT',
      tabId,
    });
  }
}
