import { useStorage } from '@plasmohq/storage/hook';

import { storage } from '~utils/storage';

export function useExtension(): UseExtensionResult {
  const [updateAvailable] = useStorage({ instance: storage, key: 'updateAvailable' });
  const { version } = chrome.runtime.getManifest();

  return {
    updateAvailable,
    version,
  };
}

export interface UseExtensionResult {
  readonly updateAvailable?: string;
  readonly version: string;
}
