export interface Action {
  readonly domain: string;
  readonly name: string;
  readonly property?: string;
  readonly selector: string;
}

export interface DomainConfig {
  readonly issue?: DomainIssue;
  readonly on: boolean;
}

export interface DomainIssue {
  readonly expiresAt?: number;
  readonly flags?: readonly string[];
  readonly url?: string;
}

export interface ExclusionMap {
  readonly domains: readonly string[];
  readonly overflows: readonly string[];
  readonly tags: readonly string[];
}

export interface ExtensionData {
  readonly actions: readonly Action[];
  readonly exclusions: ExclusionMap;
  readonly keywords: readonly string[];
  readonly rules: readonly chrome.declarativeNetRequest.Rule[];
  readonly tokens: TokenMap;
  readonly version: string;
}

export interface ReportParams {
  readonly reason: string;
  readonly url: string;
}

export interface ReportResult {
  readonly data: string;
  readonly success: boolean;
}

export interface TokenMap {
  readonly backdrops: readonly string[];
  readonly classes: readonly string[];
  readonly containers: readonly string[];
  readonly selectors: readonly string[];
}
